/******************************************************************************
**
**     File:                    GTraceDb.java
**
**     Purpose:                 
**                              
**
**     Author/Date:             Ram Periakaruppan, Sept. 14th, 1999.
**
**     References:
**      Naughton, P., Schildt, H., JAVA - The Complete Reference. McGraw Hill.
**      Eckstein, R., Loy, M., Wood, D., JAVA Swing. O'Reilly.
**      The Source For Java Technology, http://www.java.sun.com.
**
******************************************************************************/
package caida.GTrace;

import com.sleepycat.db.*;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.io.IOException;
import java.io.File;
import java.io.RandomAccessFile;
import java.util.StringTokenizer;
import java.util.NoSuchElementException;

class GTraceDb extends DbEnv
{
    private Db DbPtr;

    public GTraceDb(String dir, String dbname) throws DbException
    {
	super(dir,null, Db.DB_THREAD);

        try 
	{
            set_error_stream(System.err);
            set_errpfx("GTraceDb");
        }
        catch (Exception e) 
	{
            System.err.println(e.toString());
            System.exit(1);
        }

	DbPtr = Db.open(dbname, Db.DB_HASH, Db.DB_RDONLY, 0644, this, null);
    }


/******************************************************************************
**
**     Method name:             
**
**     Purpose:                 
**    
**     Parameters:              
**
**     Return Values:           
**                                           
**     Author/Last Modified:    Ram Periakaruppan, Sept. 15th, 1999
**
******************************************************************************/

    public DbRecord lookupkey(String skey) throws DbException
    {
	Dbt key = new Dbt(skey.getBytes());
	key.set_size(skey.length());
	Dbt data = new Dbt();
	data.set_flags(Db.DB_DBT_MALLOC);
	
	switch( DbPtr.get(null,key,data,0) )
	{
	    case 0: 
		String key_string = new String(key.get_data(), 0,
                                               key.get_size());
		String data_string = new String(data.get_data(), 0,
                                                data.get_size());
		return new DbRecord(key_string, data_string);

	    case Db.DB_NOTFOUND:
	          break;
	}
	
	return null;
    }
}
