/***************************************************************************
Copyright 1999 The Regents of the University of California
All Rights Reserved

Permission to use, copy, modify and distribute any part of the
GTrace tool for educational, research and non-profit
purposes, without fee, and without a written agreement is hereby
granted, provided that the above copyright notice, this paragraph
and the following paragraphs appear in all copies.

Those desiring to incorporate this into commercial products or use
for commercial purposes should contact the Technology Transfer
Office, University of California, San Diego, 9500 Gilman Drive, La
Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY
PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS
SOFTWARE, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
THE POSSIBILITY OF SUCH DAMAGE.

THE SOFTWARE PROVIDED HEREIN IS ON AN "AS IS" BASIS, AND THE
UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS. THE UNIVERSITY
OF CALIFORNIA MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES
OF ANY KIND, EITHER IMPLIED OR EXPRESS, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE, OR THAT THE USE OF THE SOFTWARE WILL NOT INFRINGE
ANY PATENT, TRADEMARK OR OTHER RIGHTS.

The GTrace tool is developed by Ram Periakaruppan at the University 
of California, San Diego under the Cooperative Association for Internet 
Data Analysis (CAIDA) Program. Support for this effort is provided by 
the CAIDA grant ANI-9711092, and by CAIDA members.

Report bugs and suggestions to gtrace-bugs@caida.org.
**************************************************************************/

/******************************************************************************
**
**     File:                    ToolBar.java
**
**     Purpose:                 
**                              
**
**     Author/Date:             Ram Periakaruppan, Sept. 13th, 1999.
**
**     References:
**      Naughton, P., Schildt, H., JAVA - The Complete Reference. McGraw Hill.
**      Eckstein, R., Loy, M., Wood, D., JAVA Swing. O'Reilly.
**      The Source For Java Technology, http://www.java.sun.com.
**
******************************************************************************/
package caida.GTrace;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

public class LDetailDialog extends JDialog
{
    JDialog ldetailDialog;
    JTextArea dataTArea;
    JButton cancelButton;

//---------------------------------------------------------------------------
//                             constructors
//---------------------------------------------------------------------------
    
/******************************************************************************
**
**     Purpose:                 
**    
**     Parameters:             
**
**     Author/Last Modified:    Ram Periakaruppan, Oct 18th, 1999
**
******************************************************************************/

    public LDetailDialog(JFrame frame) 
    {
	ldetailDialog = new JDialog(frame, "Location Details", false);
	ldetailDialog.setSize(390, 350);
	ldetailDialog.setResizable(false);

	// Buttons
	JButton cancelButton = new JButton("Cancel");
	cancelButton.setMnemonic('C');
	cancelButton.setBorder(BorderFactory.createRaisedBevelBorder());
	cancelButton.setAlignmentX(Component.CENTER_ALIGNMENT);    
	cancelButton.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) 
	    {
		ldetailDialog.setVisible(false);
		ldetailDialog.dispose();
	    }
	});

        dataTArea= new JTextArea();
	dataTArea.setEditable(false);
        //dataTArea.setLineWrap(false);
        JScrollPane dataTAreaScrollPane = new JScrollPane(dataTArea,
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
			        JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        dataTAreaScrollPane.setPreferredSize(new Dimension(350, 250));

        JPanel ldPane = new JPanel();
        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();

        ldPane.setLayout(gridbag);

	// ROW 1
	c.gridx = 0;
	c.gridy = 0;
	c.ipady = 0;
	c.insets = new Insets(10,10,10,10); 
	gridbag.setConstraints(dataTAreaScrollPane, c);
	ldPane.add(dataTAreaScrollPane);
	
	
	// ROW 4
	c.gridx = 0;
	c.gridy = 1;
	c.ipadx = 30;  
	c.ipady = 8;
	c.anchor = GridBagConstraints.CENTER;
	c.insets = new Insets(10,0,0,0); 
	gridbag.setConstraints(cancelButton, c);
	ldPane.add(cancelButton);

	ldetailDialog.getContentPane().add(ldPane);
	ldetailDialog.setLocationRelativeTo(frame);
    }

/******************************************************************************
**
**     Method name:             
**
**     Purpose:                 
**    
**     Parameters:              
**
**     Return Values:           
**                                           
**     Author/Last Modified:    Ram Periakaruppan, Oct. 18th, 1999
**
******************************************************************************/

    public void showDialog(String text)
    {
	int linwidth[] = Util.getNumLinesMaxWidth(text);

	dataTArea.setRows(linwidth[0]);
	dataTArea.setColumns(linwidth[1]);
	dataTArea.setText(text);

	ldetailDialog.setVisible(true);
    }

}
