/***************************************************************************
Copyright 1999 The Regents of the University of California
All Rights Reserved

Permission to use, copy, modify and distribute any part of the
GTrace tool for educational, research and non-profit
purposes, without fee, and without a written agreement is hereby
granted, provided that the above copyright notice, this paragraph
and the following paragraphs appear in all copies.

Those desiring to incorporate this into commercial products or use
for commercial purposes should contact the Technology Transfer
Office, University of California, San Diego, 9500 Gilman Drive, La
Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY
PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS
SOFTWARE, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
THE POSSIBILITY OF SUCH DAMAGE.

THE SOFTWARE PROVIDED HEREIN IS ON AN "AS IS" BASIS, AND THE
UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS. THE UNIVERSITY
OF CALIFORNIA MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES
OF ANY KIND, EITHER IMPLIED OR EXPRESS, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE, OR THAT THE USE OF THE SOFTWARE WILL NOT INFRINGE
ANY PATENT, TRADEMARK OR OTHER RIGHTS.

The GTrace tool is developed by Ram Periakaruppan at the University 
of California, San Diego under the Cooperative Association for Internet 
Data Analysis (CAIDA) Program. Support for this effort is provided by 
the CAIDA grant ANI-9711092, and by CAIDA members.

Report bugs and suggestions to gtrace-bugs@caida.org.
**************************************************************************/

/******************************************************************************
**
**     File:                    LatLon.java
**
**     Author/Date:             Ram Periakaruppan, Sept 15th, 1999.
**
**     References:
**      Naughton, P., Schildt, H., JAVA - The Complete Reference. McGraw Hill.
**      Eckstein, R., Loy, M., Wood, D., JAVA Swing. O'Reilly.
**      The Source For Java Technology, http://www.java.sun.com.
**
*****************************************************************************/
package caida.GTrace;

public class LatLon
{
    float lat;
    float lon;

//---------------------------------------------------------------------------
//                             constructors
//---------------------------------------------------------------------------

/******************************************************************************
 **
 **     Purpose:                 Initializes the member variables to the
 **                              parameters specified.
 **    
 **     Parameters:              String slat - latitude
 **                              String slon - longitude
 **
 **     Author/Last Modified:    Ram Periakaruppan, Sept 15th, 1999
 **
 *****************************************************************************/
    
    public LatLon(String slat, String slon)
    {
	try
	{
	    lat = new Float(slat).floatValue();
	    lon = new Float(slon).floatValue();
	}
	catch(NumberFormatException nfe)
	{
	    lat = Float.NaN;
	    lon = Float.NaN;
	}
    }

//---------------------------------------------------------------------------
//                             getxxx Methods
//---------------------------------------------------------------------------

/******************************************************************************
 **
 **     Method name:             getLat
 **
 **     Purpose:                 returns the latitude
 **    
 **     Parameters:              NONE
 **
 **     Return Values:           float - latitude
 **                                           
 **     Author/Last Modified:    Ram Periakaruppan, Sept. 15th, 1999
 **
 *****************************************************************************/

    public float getLat()
    {
	return lat;
    }
   
/******************************************************************************
 **
 **     Method name:             getLon
 **
 **     Purpose:                 returns the longitude
 **    
 **     Parameters:              NONE
 **
 **     Return Values:           float - longitude
 **                                           
 **     Author/Last Modified:    Ram Periakaruppan, Sept. 15th, 1999
 **
 *****************************************************************************/

    public float getLon()
    {
	return lon;
    }
}
