/***************************************************************************
Copyright 1999 The Regents of the University of California
All Rights Reserved

Permission to use, copy, modify and distribute any part of the
GTrace tool for educational, research and non-profit
purposes, without fee, and without a written agreement is hereby
granted, provided that the above copyright notice, this paragraph
and the following paragraphs appear in all copies.

Those desiring to incorporate this into commercial products or use
for commercial purposes should contact the Technology Transfer
Office, University of California, San Diego, 9500 Gilman Drive, La
Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY
PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS
SOFTWARE, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
THE POSSIBILITY OF SUCH DAMAGE.

THE SOFTWARE PROVIDED HEREIN IS ON AN "AS IS" BASIS, AND THE
UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS. THE UNIVERSITY
OF CALIFORNIA MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES
OF ANY KIND, EITHER IMPLIED OR EXPRESS, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE, OR THAT THE USE OF THE SOFTWARE WILL NOT INFRINGE
ANY PATENT, TRADEMARK OR OTHER RIGHTS.

The GTrace tool is developed by Ram Periakaruppan at the University 
of California, San Diego under the Cooperative Association for Internet 
Data Analysis (CAIDA) Program. Support for this effort is provided by 
the CAIDA grant ANI-9711092, and by CAIDA members.

Report bugs and suggestions to gtrace-bugs@caida.org.
**************************************************************************/

/******************************************************************************
**
**     File:                    MapException.java
**
**     Purpose:                 
**                              
**
**     Author/Date:             Ram Periakaruppan, July 12th, 1999.
**
**     References:
**      Naughton, P., Schildt, H., JAVA - The Complete Reference. McGraw Hill.
**      Eckstein, R., Loy, M., Wood, D., JAVA Swing. O'Reilly.
**      The Source For Java Technology, http://www.java.sun.com.
**
****************************************************************************/
package caida.GTrace;

public class MapException extends Exception
{
    private int excpno; //exception number

    // Constants
    final static int BoundaryFormat = 1;
    final static int MoreThanOneParent = 2;
    final static int InvalidMapDescriptionAttribute = 3;
    final static int MalFormedLabel = 4;

//---------------------------------------------------------------------------
//                             constructors
//---------------------------------------------------------------------------

/******************************************************************************
 **
 **     Purpose:                 
 **    
 **     Parameters:             
 **
 **     Author/Last Modified:    Ram Periakaruppan, July 12th, 1999
 **
 *****************************************************************************/
    
    public MapException(int excpno)
    {
	this.excpno = excpno;
    }

/******************************************************************************
 **
 **     Method name:             
 **
 **     Purpose:                 
 **    
 **     Parameters:              
 **
 **     Return Values:           
 **                                           
 **     Author/Last Modified:    Ram Periakaruppan, July 12nd, 1999
 **
 *****************************************************************************/
    
    public String toString()
    {
	switch(excpno)
	{
        case BoundaryFormat:
            return "Incorrectly formatted boundary "
                + "[top_lon,top_lat,bot_lon,bot_lat]";
        case InvalidMapDescriptionAttribute:
            return "Invalid Map Description Attribute, valid attributes "
                + "are 'c:' for specifying children and 'p:' for "
                + "specifying a parent";
        default:
            return "MapException";
	}
    }
}
